(****************************************************************************)
(*                 The Calculus of Inductive Constructions                  *)
(*                                                                          *)
(*                                Projet Coq                                *)
(*                                                                          *)
(*                     INRIA        LRI-CNRS        ENS-CNRS                *)
(*              Rocquencourt         Orsay          Lyon                    *)
(*                                                                          *)
(*                                 Coq V6.2                                 *)
(*                               May 1st 1998                               *)
(*                                                                          *)
(****************************************************************************)
(*                         A_decidable_ordering.v                           *)
(****************************************************************************)

(* G. Huet 1-9-95 *)

(* This is needed in order to have parametric lists and multisets share
   the same abstract type A, in the absence of parametric modules *)
Require Generic.

(**********************************************)
(* We postulate a decidable equality equ on A *)
(**********************************************)

Parameter   equ : A -> A -> Prop.
Axiom equ_decide : (x,y:A){(equ x y)}+{~(equ x y)}.


(* $Id: A_decidable.v,v 1.3 1998/04/30 16:45:55 mohring Exp $ *)
